package com.docus.server.controller;

import com.docus.core.util.DateUtil;
import com.docus.core.util.json.JSON;
import com.docus.server.api.scheduling.management.CommMsgApi;
import com.docus.server.common.netty.CommMsg;
import com.docus.server.common.netty.server.ChannelRepository;
import com.docus.server.convert.CommMsgConvert;
import com.docus.server.dto.scheduling.management.schterminator.CommMsgDTO;
import io.netty.buffer.Unpooled;
import io.netty.channel.Channel;
import io.netty.util.CharsetUtil;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.Date;

/**
 * 通用消息体 TCP API
 *
 * @author AutoGenerator
 * @since 2023-07-15
 */
@RestController
public class CommMsgController implements CommMsgApi {
    @Resource
    private ChannelRepository channelRepository;

    @Override
    public void clientCommand(CommMsgDTO commMsgDTO) {
        Channel channel = channelRepository.get(commMsgDTO.getTerminatorIp());

        CommMsg commMsg = CommMsgConvert.INSTANCE.convertDO(commMsgDTO);
        commMsg.setMessageTime(DateUtil.formatDateTime(new Date()));

        if (channel != null) {
            channel.writeAndFlush(Unpooled.copiedBuffer(JSON.toJSON(commMsg), CharsetUtil.UTF_8));
        }
    }
}
